#ifndef CORE_USB_USB
#define CORE_USB_USB

#include <stdint.h>

#include "usb_driver_common.h"

void usbcore_init(USB_DrvIntf *drvIntf);                                                // initialize USB core
uint32_t usbcore_schedule_transmission(uint8_t ep, const uint8_t *data, uint16_t size); // write data to endpoint, return with number of bytes actually written
uint32_t usbcore_schedule_reception(uint8_t ep, uint16_t size);                         // expect data coming from the endpoint
void usbcore_wake_up_endpoint(uint8_t ep, uint8_t dir);                                 // wake up endpoint
void usbcore_register_IN_callback(uint8_t ep, USBDRV_IN_cb cb);                         // register IN complete callback

#endif /* CORE_USB_USB */
